#ifndef BASIC_WINDOW_H
#define BASIC_WINDOW_H


class CBasicWindow {
protected:
	HWND m_hwnd;
	struct {
		int Left,Top;
		int Width,Height;
	} m_WindowPosition;
	bool CreateBasicWindow(HWND hwndParent,DWORD Style,DWORD ExStyle,int ID,
						LPCTSTR pszClassName,LPCTSTR pszText,HINSTANCE hinst);
	void OnDestroy();
public:
	CBasicWindow();
	virtual ~CBasicWindow();
	virtual bool Create(HWND hwndParent,DWORD Style,DWORD ExStyle=0,int ID=0)=0;
	void Destroy();
	bool SetPosition(int Left,int Top,int Width,int Height);
	bool SetPosition(const RECT *pPosition);
	void GetPosition(int *pLeft,int *pTop,int *pWidth,int *pHeight) const;
	void GetPosition(RECT *pPosition) const;
	virtual void SetVisible(bool fVisible);
	bool GetVisible() const;
	bool GetMaximize() const;
	HWND GetHandle() { return m_hwnd; }
	bool Invalidate(bool fErase=true);
	bool Update();
	bool GetClientRect(RECT *pRect) const;
	bool GetClientSize(SIZE *pSize) const;
	bool SetParent(HWND hwnd);
	bool SetParent(CBasicWindow *pWindow);
	HWND GetParent() const;
	bool MoveToMonitorInside();
};


#endif
