#ifndef CHANNEL_LIST_H
#define CHANNEL_LIST_H


#define FIRST_UHF_CHANNEL 13
#define MAX_CHANNEL_NAME 64


class CChannelInfo {
	int m_Space;			// `[jO
	int m_Channel;			// `lԍ
	int m_ChannelIndex;		// `lCfbNX(BonDriverł̔ԍ)
	int m_ChannelNo;		// R`lԍ
	TCHAR m_szName[MAX_CHANNEL_NAME];
public:
	CChannelInfo(int Space,int Channel,int Index,int No,LPCTSTR pszName);
	CChannelInfo(const CChannelInfo &Info);
	int GetSpace() const { return m_Space; }
	int GetChannel() const { return m_Channel; }
	int GetChannelIndex() const { return m_ChannelIndex; }
	int GetChannelNo() const { return m_ChannelNo; }
	LPCTSTR GetName() const { return m_szName; }
};

class CChannelList {
	int m_NumChannels;
	class CChannelInfo **m_ppList;
	int m_ListLength;
public:
	CChannelList();
	~CChannelList();
	int NumChannels() const { return m_NumChannels; }
	bool AddChannel(int Space,int Channel,int Offset,int No,LPCTSTR pszName);
	bool AddChannel(const CChannelInfo &Info);
	const CChannelInfo *GetChannelInfo(int No) const;
	int GetSpace(int No) const;
	int GetChannel(int No) const;
	int GetChannelNo(int No) const;
	int GetChannelIndex(int No) const;
	LPCTSTR GetName(int No) const;
	void Clear();
	int FindChannelNo(int No) const;
	int GetNextChannelNo(int ChannelNo,bool fWrap=false) const;
	int GetPrevChannelNo(int ChannelNo,bool fWrap=false) const;
	int GetMaxChannelNo() const;
};

class CTuningSpaceList {
	CChannelList **m_ppChannelList;
	int m_NumSpaces;
public:
	CTuningSpaceList();
	~CTuningSpaceList();
	int NumSpaces() const { return m_NumSpaces; }
	CChannelList *GetChannelList(int Space);
	const CChannelList *GetChannelList(int Space) const;
	bool Create(const CChannelList *pList,int NumSpaces);
	bool Reserve(int NumSpaces);
	void Clear();
};


#endif
