// DtvEngine.cpp: CDtvEngine NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DtvEngine.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//////////////////////////////////////////////////////////////////////
// CDtvEngine \z/
//////////////////////////////////////////////////////////////////////

CDtvEngine::CDtvEngine(void)
	: m_pDtvEngineHandler(NULL)
	, m_wCurTransportStream(0U)
	, m_wCurService(0xFFFFU)
	, m_wCurVideoPID(0x1FFFU)
	, m_wCurAudioPID(0x1FFFU)
	, m_u64CurPcrTimeStamp(0UL)
	, m_BonSrcDecoder(this)
	, m_TsPacketParser(this)
	, m_TsDescrambler(this)
	, m_ProgManager(this)
	, m_MediaViewer(this)
	, m_MediaTee(this)
	, m_FileWriter(this)
	, m_FileReader(this)
	, m_bBuiled(false)
	, m_bIsFileMode(false)
	, m_pTracer(NULL)
{

}

CDtvEngine::~CDtvEngine(void)
{
	CloseEngine();
}

const bool CDtvEngine::BuildEngine(CDtvEngineHandler *pDtvEngineHandler, HWND hHostHwnd,HWND hMessageDrainHwnd,bool bDescramble,LPCWSTR pszMpeg2Decoder)
{
	// SɎb
	if(m_bBuiled) return true;

	// Ot\}
	//
	// m_BonSrcDecoder or m_FileReader
	//		
	// m_TsPacketParser
	//		
	// m_TsDescrambler
	//		
	// m_MediaTee
	//						
	// m_ProgManager	m_FileWriter
	//		
	// m_MediaViewer

	Trace(TEXT("fR[_Ot\zĂ܂..."));

	// fR[_Ot\z
	if(bDescramble){
		// fXNuʂ
		m_TsPacketParser.SetOutputDecoder(&m_TsDescrambler);// Output #0 : CTsPacket
		m_TsDescrambler.SetOutputDecoder(&m_MediaTee);		// Output #0 : CTsPacket
	} else {
		// fXNuʂȂ
		m_TsPacketParser.SetOutputDecoder(&m_MediaTee);		// Output #0 : CTsPacket
	}
	m_MediaTee.SetOutputDecoder(&m_ProgManager, 0UL);		// Output #0 : CTsPacket
	m_MediaTee.SetOutputDecoder(&m_FileWriter, 1UL);		// Output #1 : CTsPacket
	m_ProgManager.SetOutputDecoder(&m_MediaViewer);			// Output #0 : CTsPacket


	// Cxgnhݒ
	m_pDtvEngineHandler = pDtvEngineHandler;

	try{
		if(bDescramble){
			Trace(TEXT("B-CASJ[hJĂ܂..."));
			// B-CASJ[hJ
			if(!m_TsDescrambler.OpenBcasCard())throw 2UL;
			}

		// r[AJ
		m_MediaViewer.SetTracer(m_pTracer);
		if(!m_MediaViewer.OpenViewer(hHostHwnd,hMessageDrainHwnd,pszMpeg2Decoder))throw 3UL;
		}
	catch(DWORD dwErrorNo){
		// G[
		switch(dwErrorNo){
		/*
		case 1UL:
			::MessageBox(hHostHwnd,TEXT("`[ȉɎs܂B"),
											NULL,MB_OK | MB_ICONEXCLAMATION);
			break;
		*/
		case 2UL:
			::MessageBox(hHostHwnd,TEXT("B-CASJ[h̏Ɏs܂B"),
											NULL,MB_OK | MB_ICONEXCLAMATION);
			break;
		case 3UL:
			::MessageBox(hHostHwnd,TEXT("DirectShow̏Ɏs܂B"),
											NULL,MB_OK | MB_ICONEXCLAMATION);
			break;
		}
		CloseEngine();
		
		return false;
		}
	
	return true;
}

const bool CDtvEngine::CloseEngine(void)
{
	ReleaseSrcFilter();
	// fR[_N[Y
	m_BonSrcDecoder.CloseTuner();
	m_TsDescrambler.CloseBcasCard();
	m_MediaViewer.CloseViewer();

	// Cxgnh
	m_pDtvEngineHandler = NULL;
	m_bBuiled=false;

	return true;
}

const bool CDtvEngine::ResetEngine(void)
{
	// fR[_OtZbg
	m_wCurTransportStream = 0;
	m_wCurVideoPID = m_wCurAudioPID = 0;
	m_BonSrcDecoder.Reset();

	return true;
}

const bool CDtvEngine::OpenSrcFilter_BonDriver(HMODULE hBonDriverDll)
{
	// \[XtB^J
	Trace(TEXT("`[iJĂ܂..."));
	if(!m_BonSrcDecoder.OpenTuner(hBonDriverDll)){
		return false;
		}
	if(!m_BonSrcDecoder.Play()){
		return false;
		}
	m_BonSrcDecoder.SetOutputDecoder(&m_TsPacketParser);
	ResetEngine();

	m_bIsFileMode = false;
	return true;
}

const bool CDtvEngine::OpenSrcFilter_File(LPCTSTR lpszFileName)
{
	// t@CJ
	if(!m_FileReader.OpenFile(lpszFileName)){
		return false;
		}
	if(!m_FileReader.StartReadAnsync()){
		return false;
		}
	m_FileReader.SetOutputDecoder(&m_TsPacketParser);
	ResetEngine();

	m_bIsFileMode = true;
	return true;
}

const bool CDtvEngine::ReleaseSrcFilter()
{
	// \[XtB^J
	m_BonSrcDecoder.CloseTuner();
	m_BonSrcDecoder.SetOutputDecoder(NULL);
	m_FileReader.StopReadAnsync();
	m_FileReader.CloseFile();
	m_FileReader.SetOutputDecoder(NULL);
	return true;
}

const bool CDtvEngine::EnablePreview(const bool bEnable)
{
	if(bEnable){
		// vr[L
		if(!m_MediaViewer.Play())return false;
		}
	else{
		// vr[
		if(!m_MediaViewer.Stop())return false;
		}

	return true;
}

const bool CDtvEngine::SetViewSize(const int x,const int y)
{
	// EBhETCYݒ肷
	return m_MediaViewer.SetViewSize(x,y);
}

const bool CDtvEngine::SetVolume(const float fVolume)
{
	// I[fBI{[ݒ肷( -100.0() < fVolume < 0(ő) )
	return m_MediaViewer.SetVolume(fVolume);
}

const bool CDtvEngine::GetVideoSize(WORD *pwWidth,WORD *pwHeight)
{
	return m_MediaViewer.GetVideoSize(pwWidth,pwHeight);
}

const bool CDtvEngine::GetVideoAspectRatio(BYTE *pbyAspectRateX,BYTE *pbyAspectRateY)
{
	return m_MediaViewer.GetVideoAspectRatio(pbyAspectRateX,pbyAspectRateY);
}

const BYTE CDtvEngine::GetAudioCahnnelNum()
{
	return m_MediaViewer.GetAudioChannelNum();
}

const bool CDtvEngine::SetStereoMode(int iMode)
{
	return m_MediaViewer.SetStereoMode(iMode);
}

const bool CDtvEngine::GetVideoDecorderName(LPWSTR lpName,int iBufLen)
{
	return m_MediaViewer.GetVideoDecorderName(lpName, iBufLen);
}

const bool CDtvEngine::DisplayVideoDecorderProperty(HWND hWndParent)
{
	return m_MediaViewer.DisplayVideoDecorderProperty(hWndParent);
}

const bool CDtvEngine::SetChannel(const BYTE byTuningSpace, const WORD wChannel)
{
	// `lύX
	bool bRet = m_BonSrcDecoder.SetChannel((DWORD)byTuningSpace, (DWORD)wChannel);
	if(bRet) ResetEngine();
	return bRet;
}

const bool CDtvEngine::SetService(const WORD wService)
{
	// T[rXύX(wService==0xFFFFȂPAT擪T[rX)

	if(wService < m_ProgManager.GetServiceNum() || wService==0xFFFF){
		WORD wServiceID = 0xFFFF;
		WORD wVideoPID = 0xFFFF;
		WORD wAudioPID = 0xFFFF;

		// 擪PMT܂Ŏsɂ
		if(!m_ProgManager.GetServiceID(&wServiceID,wService)) return false;
		if(wService==0xFFFF){
			m_wCurService = 0;
			m_wCurVideoPID = m_wCurAudioPID = 0;
		} else {
			m_wCurService = wService;
		}
		
		m_ProgManager.GetServiceEsPID(&wVideoPID, &wAudioPID, m_wCurService);

		TRACE(TEXT("------- Service Select -------\n"));
		TRACE(TEXT("ServiceID = %04X(%d)\n"),m_wCurService,wServiceID);

		if(m_wCurVideoPID != wVideoPID){
			m_MediaViewer.SetVideoPID(wVideoPID);
			m_wCurVideoPID = wVideoPID;
			TRACE(TEXT("Change Video PID = %04X\n"),wVideoPID);
			}
		if(m_wCurAudioPID != wAudioPID){
			m_MediaViewer.SetAudioPID(wAudioPID);
			m_wCurAudioPID = wAudioPID;
			TRACE(TEXT("Change Audio PID = %04X\n"),wAudioPID);
			}
		
		return true;
		}

	return false;
}

const WORD CDtvEngine::GetService(void) const
{
	// T[rX擾
	return m_wCurService;
}

const unsigned __int64 CDtvEngine::GetPcrTimeStamp() const
{
	// PCR^CX^v擾
	return m_u64CurPcrTimeStamp;
}

#if 0
const bool CDtvEngine::PlayFile(LPCTSTR lpszFileName)
{
	// OtŜ̔rȂƂ܂ƂɓȂII

	// Đ̏ꍇ͕
	m_FileReader.StopReadAnsync();

	// XbhI҂
	while(m_FileReader.IsAnsyncReadBusy()){
		::Sleep(1UL);
		}

	m_FileReader.CloseFile();

	// foCXĐ̏ꍇ̓Otč\z
	if(!m_bIsFileMode){
		m_BonSrcDecoder.Stop();
		m_BonSrcDecoder.SetOutputDecoder(NULL);
		m_FileReader.SetOutputDecoder(&m_TsPacketParser);
		}

	try{
		// OtZbg
		m_FileReader.Reset();

		// t@CI[v
		if(!m_FileReader.OpenFile(lpszFileName))throw 0UL;
		
		// 񓯊ĐJn
		if(!m_FileReader.StartReadAnsync())throw 1UL;
		}
	catch(const DWORD dwErrorStep){
		// G[
		StopFile();
		return false;
		}

	m_bIsFileMode = true;

	return true;
}

void CDtvEngine::StopFile(void)
{
	// OtŜ̔rȂƂ܂ƂɓȂII

	m_bIsFileMode = false;

	// Đ̏ꍇ͕
	m_FileReader.StopReadAnsync();
	
	// XbhI҂
	while(m_FileReader.IsAnsyncReadBusy()){
		::Sleep(1UL);
		}

	m_FileReader.CloseFile();
	
	// Otč\z
	m_FileReader.SetOutputDecoder(NULL);
	m_BonSrcDecoder.SetOutputDecoder(&m_TsPacketParser);
	m_BonSrcDecoder.Play();
}
#endif

const DWORD CDtvEngine::GetLastError(void) const
{
	return 0UL;
}

const DWORD CDtvEngine::SendDtvEngineEvent(const DWORD dwEventID, PVOID pParam)
{
	// CxgnhɃCxg𑗐M
	if(m_pDtvEngineHandler){
		return m_pDtvEngineHandler->OnDtvEngineEvent(this, dwEventID, pParam);
		}

	return 0UL;
}

const DWORD CDtvEngine::OnDecoderEvent(CMediaDecoder *pDecoder, const DWORD dwEventID, PVOID pParam)
{
	// fR[_̃Cxg󂯎(b)
	if(pDecoder == &m_ProgManager){
		
		// vO}l[W̃Cxg
		WORD wTransportStream = m_ProgManager.GetTransportStreamID();
		switch(dwEventID){
			case CProgManager::EID_SERVICE_LIST_UPDATED :
				// T[rX̍\ω				
				if(m_wCurTransportStream!=wTransportStream) {
					// Xg[IDςĂȂ珉
					TRACE(TEXT("Stream Change!! %04X\n"),wTransportStream);
					// ̎_ł܂T[rXSĂȂƂ̂ŁAۗ
					if(SetService(0xFFFF)){
						m_wCurTransportStream = wTransportStream;
						SendDtvEngineEvent(EID_SERVICE_LIST_UPDATED, static_cast<PVOID>(&m_ProgManager));
						}
				} else {
					// Xg[ID͓A\ESPIDς\
					SetService(m_wCurService);
				}
				return 0UL;
				
			case CProgManager::EID_SERVICE_INFO_UPDATED :
				// T[rXXVꂽ
				SendDtvEngineEvent(EID_SERVICE_INFO_UPDATED, static_cast<PVOID>(&m_ProgManager));
				
				return 0UL;
			case CProgManager::EID_PCR_TIMESTAMP_UPDATED :
				// ^CX^vXVꂽ
				if(m_wCurService!=0xFFFF){
					m_ProgManager.GetPcrTimeStamp(&m_u64CurPcrTimeStamp,m_wCurService);
					}
				SendDtvEngineEvent(EID_PCR_TIMESTAMP_UPDATED, static_cast<PVOID>(&m_ProgManager));
				return 0UL;
			}
		}
	else if(pDecoder == &m_FileReader){
		
		CFileReader *pFileReader = dynamic_cast<CFileReader *>(pDecoder);
		
		// t@C[_̃Cxg
		switch(dwEventID){
			case CFileReader::EID_READ_ASYNC_START :
				// 񓯊[hJn
				return 0UL;
			
			case CFileReader::EID_READ_ASYNC_END :
				// 񓯊[hI
				return 0UL;
			
			case CFileReader::EID_READ_ASYNC_POSTREAD :
				// 񓯊[h
				
				if(pFileReader->GetReadPos() >= pFileReader->GetFileSize()){
					// ŏɊ߂([vĐ)
					pFileReader->SetReadPos(0ULL);
					pFileReader->Reset();
					ResetEngine();
					}
				
				return 0UL;
			}		
		}

	return 0UL;
}




bool CDtvEngine::GetOriginalVideoSize(WORD *pWidth,WORD *pHeight) const
{
	return m_MediaViewer.GetOriginalVideoSize(pWidth,pHeight);
}


CEpgDataInfo *CDtvEngine::GetEpgDataInfo(WORD wSID, bool bNext)
{
	WORD wID = 0;

	m_ProgManager.GetServiceID(&wID,wSID);
	return m_TsPacketParser.GetEpgDataInfo(wID,bNext);
}


bool CDtvEngine::SetTracer(CTracer *pTracer)
{
	m_pTracer=pTracer;
	return true;
}


void CDtvEngine::Trace(LPCTSTR pszOutput, ...)
{
	va_list Args;

	va_start(Args,pszOutput);
	if (m_pTracer!=NULL)
		m_pTracer->TraceV(pszOutput,Args);
	va_end(Args);
}


//////////////////////////////////////////////////////////////////////
// CDtvEngineHandler \z/
//////////////////////////////////////////////////////////////////////

const DWORD CDtvEngineHandler::OnDtvEngineEvent(CDtvEngine *pEngine, const DWORD dwEventID, PVOID pParam)
{
	// ftHg̏
	return 0UL;
}
